"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _glamor = require("glamor");

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _cpDesignSystemButton = _interopRequireDefault(require("@catapult-tech/cp-design-system-button"));

var _cpDesignSystemText = require("@catapult-tech/cp-design-system-text");

var _cpDesignSystemTheme = require("@catapult-tech/cp-design-system-theme");

var _index = _interopRequireDefault(require("../css/index.js"));

var _heading = _interopRequireDefault(require("./heading.js"));

var _iconLoader = _interopRequireDefault(require("./icon-loader.js"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var styles = {
  page: function page(_ref) {
    var themeName = _ref.themeName;
    var label = 'psds-error-page';
    return (0, _glamor.compose)((0, _glamor.css)(_index.default[".".concat(label)]), (0, _glamor.css)(_index.default[".".concat(label, ".psds-theme--").concat(themeName)]), (0, _glamor.media)('(min-width: 769px)', _index.default['@media (min-width: 769px)'][".".concat(label)]));
  },
  icon: function icon(_ref2) {
    var themeName = _ref2.themeName;
    var label = 'psds-error-page__icon';
    return (0, _glamor.compose)((0, _glamor.css)(_index.default[".".concat(label)]), (0, _glamor.css)(_index.default[".".concat(label, ".psds-theme--").concat(themeName)]));
  },
  text: function text() {
    var label = 'psds-error-page__text';
    return (0, _glamor.media)('(min-width: 769px)', _index.default['@media (min-width: 769px)'][".".concat(label)]);
  },
  code: function code(_ref3) {
    var themeName = _ref3.themeName;
    return (0, _glamor.css)(_index.default['.psds-error-page__code'], _index.default[".psds-error-page__code.psds-theme--".concat(themeName)]);
  },
  search: function search(_ref4) {
    var themeName = _ref4.themeName;
    var label = 'psds-error-page__search';
    return (0, _glamor.compose)((0, _glamor.css)(_index.default[".".concat(label)]), (0, _glamor.css)(_index.default[".".concat(label, ".psds-theme--").concat(themeName)]));
  },
  searchIcon: function searchIcon(_ref5) {
    var themeName = _ref5.themeName;
    return (0, _glamor.css)(_index.default['.psds-error-page__search__icon'], _index.default[".psds-error-page__search__icon.psds-theme--".concat(themeName)]);
  },
  searchInput: function searchInput(_ref6) {
    var themeName = _ref6.themeName;
    var label = 'psds-error-page__search__input';
    return (0, _glamor.compose)((0, _glamor.css)(_index.default[".".concat(label)]), (0, _glamor.css)(_index.default[".".concat(label, ".psds-theme--").concat(themeName)]));
  }
};

var SearchForm = function SearchForm(props) {
  return /*#__PURE__*/_react.default.createElement("form", _extends({
    action: props.action,
    method: "get"
  }, styles.search(props)), /*#__PURE__*/_react.default.createElement("div", styles.searchIcon(props), _iconLoader.default.search()), /*#__PURE__*/_react.default.createElement("input", _extends({}, styles.searchInput(props), {
    type: "text",
    name: "q",
    placeholder: "Search"
  })));
};

SearchForm.propTypes = {
  action: _propTypes.default.string
};

var ErrorPage = function ErrorPage(props) {
  var themeName = (0, _cpDesignSystemTheme.useTheme)();

  var allProps = _objectSpread(_objectSpread({}, props), {}, {
    themeName: themeName
  });

  return /*#__PURE__*/_react.default.createElement("div", styles.page(allProps), allProps.iconId && _iconLoader.default[allProps.iconId] && /*#__PURE__*/_react.default.createElement("div", styles.icon(allProps), _iconLoader.default[allProps.iconId]()), /*#__PURE__*/_react.default.createElement("div", styles.text(allProps), /*#__PURE__*/_react.default.createElement(_heading.default, {
    size: _cpDesignSystemText.headingSizes.medium
  }, /*#__PURE__*/_react.default.createElement("h1", null, allProps.text))), /*#__PURE__*/_react.default.createElement("div", styles.code(allProps), /*#__PURE__*/_react.default.createElement(_heading.default, {
    size: _cpDesignSystemText.headingSizes.smallCaps
  }, /*#__PURE__*/_react.default.createElement("h2", null, "Error code: ", allProps.code))), allProps.href && /*#__PURE__*/_react.default.createElement(_cpDesignSystemButton.default, {
    href: allProps.href
  }, "Contact support"), allProps.action && /*#__PURE__*/_react.default.createElement(SearchForm, allProps));
};

ErrorPage.propTypes = {
  action: _propTypes.default.string,
  code: _propTypes.default.string,
  href: _propTypes.default.string,
  iconId: _propTypes.default.oneOf(Object.keys(_iconLoader.default)),
  text: _propTypes.default.string
};
var _default = ErrorPage;
exports.default = _default;