function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import { compose, css, media } from 'glamor';
import PropTypes from 'prop-types';
import React from 'react';
import Button from '@catapult-tech/cp-design-system-button';
import { headingSizes } from '@catapult-tech/cp-design-system-text';
import { useTheme } from '@catapult-tech/cp-design-system-theme';
import stylesheet from '../css/index.js';
import Heading from './heading.js';
import icons from './icon-loader.js';
var styles = {
  page: function page(_ref) {
    var themeName = _ref.themeName;
    var label = 'psds-error-page';
    return compose(css(stylesheet[".".concat(label)]), css(stylesheet[".".concat(label, ".psds-theme--").concat(themeName)]), media('(min-width: 769px)', stylesheet['@media (min-width: 769px)'][".".concat(label)]));
  },
  icon: function icon(_ref2) {
    var themeName = _ref2.themeName;
    var label = 'psds-error-page__icon';
    return compose(css(stylesheet[".".concat(label)]), css(stylesheet[".".concat(label, ".psds-theme--").concat(themeName)]));
  },
  text: function text() {
    var label = 'psds-error-page__text';
    return media('(min-width: 769px)', stylesheet['@media (min-width: 769px)'][".".concat(label)]);
  },
  code: function code(_ref3) {
    var themeName = _ref3.themeName;
    return css(stylesheet['.psds-error-page__code'], stylesheet[".psds-error-page__code.psds-theme--".concat(themeName)]);
  },
  search: function search(_ref4) {
    var themeName = _ref4.themeName;
    var label = 'psds-error-page__search';
    return compose(css(stylesheet[".".concat(label)]), css(stylesheet[".".concat(label, ".psds-theme--").concat(themeName)]));
  },
  searchIcon: function searchIcon(_ref5) {
    var themeName = _ref5.themeName;
    return css(stylesheet['.psds-error-page__search__icon'], stylesheet[".psds-error-page__search__icon.psds-theme--".concat(themeName)]);
  },
  searchInput: function searchInput(_ref6) {
    var themeName = _ref6.themeName;
    var label = 'psds-error-page__search__input';
    return compose(css(stylesheet[".".concat(label)]), css(stylesheet[".".concat(label, ".psds-theme--").concat(themeName)]));
  }
};

var SearchForm = function SearchForm(props) {
  return /*#__PURE__*/React.createElement("form", _extends({
    action: props.action,
    method: "get"
  }, styles.search(props)), /*#__PURE__*/React.createElement("div", styles.searchIcon(props), icons.search()), /*#__PURE__*/React.createElement("input", _extends({}, styles.searchInput(props), {
    type: "text",
    name: "q",
    placeholder: "Search"
  })));
};

SearchForm.propTypes = {
  action: PropTypes.string
};

var ErrorPage = function ErrorPage(props) {
  var themeName = useTheme();

  var allProps = _objectSpread(_objectSpread({}, props), {}, {
    themeName: themeName
  });

  return /*#__PURE__*/React.createElement("div", styles.page(allProps), allProps.iconId && icons[allProps.iconId] && /*#__PURE__*/React.createElement("div", styles.icon(allProps), icons[allProps.iconId]()), /*#__PURE__*/React.createElement("div", styles.text(allProps), /*#__PURE__*/React.createElement(Heading, {
    size: headingSizes.medium
  }, /*#__PURE__*/React.createElement("h1", null, allProps.text))), /*#__PURE__*/React.createElement("div", styles.code(allProps), /*#__PURE__*/React.createElement(Heading, {
    size: headingSizes.smallCaps
  }, /*#__PURE__*/React.createElement("h2", null, "Error code: ", allProps.code))), allProps.href && /*#__PURE__*/React.createElement(Button, {
    href: allProps.href
  }, "Contact support"), allProps.action && /*#__PURE__*/React.createElement(SearchForm, allProps));
};

ErrorPage.propTypes = {
  action: PropTypes.string,
  code: PropTypes.string,
  href: PropTypes.string,
  iconId: PropTypes.oneOf(Object.keys(icons)),
  text: PropTypes.string
};
export default ErrorPage;