function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import { compose, css } from 'glamor';
import PropTypes from 'prop-types';
import React from 'react';
import { css as textStylesheet } from '@catapult-tech/cp-design-system-text';
import { useTheme } from '@catapult-tech/cp-design-system-theme';

var rmChildren = function rmChildren(_ref) {
  var children = _ref.children,
      rest = _objectWithoutProperties(_ref, ["children"]);

  return rest;
};

var styles = {
  text: function text(_ref2) {
    var size = _ref2.size,
        themeName = _ref2.themeName;
    return compose(css(textStylesheet['.psds-text__heading']), css(textStylesheet[".psds-text__heading.psds-theme--".concat(themeName)]), css(textStylesheet[".psds-text__heading--size-".concat(size)]), css(textStylesheet[".psds-text__heading--size-".concat(size, ".psds-theme--").concat(themeName)]));
  }
};

var Heading = function Heading(props) {
  var themeName = useTheme();
  return /*#__PURE__*/React.cloneElement(React.Children.only(props.children), _objectSpread(_objectSpread({}, rmChildren(props)), styles.text(_objectSpread(_objectSpread({}, props), {}, {
    themeName: themeName
  }))));
};

Heading.propTypes = {
  themeName: PropTypes.string
};
export default Heading;